///////////////////////////////////////////////////////////////////////////////////////////////////
// This Alpha-blending Sample was done by "Niki" for the PPEE-Homepage (http://cust.nol.at/ppee) //
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef __ALPHABLITTER_H__
#define __ALPHABLITTER_H__

typedef unsigned char                   VoByte;

typedef unsigned short                  VoUInt16;
typedef signed short                    VoInt16;

typedef unsigned long                   VoUInt32;
typedef signed long                     VoInt32;

typedef unsigned int                    VoUInt;

/////////////////////////////////////////////////////////////////////////////////////////
// abstract alpha blitter class
/////////////////////////////////////////////////////////////////////////////////////////

class CAlphaBlitter
{
        public:
                virtual HRESULT DarkenBlock50(
                        DDSURFACEDESC2& r_destSurface,
                        int destX,
                        int destY,
                        VoUInt width,
                        VoUInt height) = 0;

                virtual HRESULT AlphaBlt(
                        DDSURFACEDESC2& r_destSurface,
                        int destX,
                        int destY,
                        DDSURFACEDESC2& r_srcSurface,
                        RECT * p_srcRect,
                        VoByte alpha) = 0;

                virtual HRESULT AlphaBltFire(
                        DDSURFACEDESC2& r_destSurface,
                        int destX,
                        int destY,
                        DDSURFACEDESC2& r_srcSurface,
                        RECT * p_srcRect ) = 0;

                virtual HRESULT AlphaBltGlass(
                        DDSURFACEDESC2& r_destSurface,
                        int destX,
                        int destY,
                        DDSURFACEDESC2& r_srcSurface,
                        RECT * p_srcRect ) = 0;

                virtual HRESULT AlphaBltEx(
                        DDSURFACEDESC2& r_destSurface,
                        int destX,
                        int destY,
                        DDSURFACEDESC2& r_srcSurface,
                        RECT * p_srcRect,
                        DDSURFACEDESC2& r_alphaSurface) = 0;
};

// CAlphaBlitter * NewAlphaBlitter(DDPIXELFORMAT& r_pixelFormat);
CAlphaBlitter * NewAlphaBlitter(IDirectDrawSurface7 *pDDSurface);

#endif
