//---------------------------------------------------------------------------
// Copyright (C) 1999 by Dmitriy Vassiliev
// SlyDiman@mail.ru
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#ifndef DDSurfacH
#define DDSurfacH

//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>

#include "DDCanvas.h"
#include "DDForm.h"

#include "LoadPcx.h"

#pragma option push -b
enum TDDSFileType { ddsBmp, ddsPcx };
#pragma option pop

//---------------------------------------------------------------------------
class PACKAGE TDDSurface : public TComponent
{
protected:
    TDDForm *DDForm;
    AnsiString FFileName;
    int FWidth;
    int FHeight;
    bool FLocked;
    bool FAutoColorKey;
    TDDSFileType FFileType;

    TNotifyEvent FOnUpdate;
    TNotifyEvent FOnInit;

public:
    TDDCanvas *pDDCanvas;
    IDirectDrawSurface7 *pDDSurface;
    DDSURFACEDESC2 SurfaceDesc;

    void __fastcall Init(void);
    void __fastcall Release(void);
    void __fastcall Update(void);

    void __fastcall Lock(void);
    void __fastcall Unlock(void);

    __fastcall TDDSurface(TComponent* Owner);
    __fastcall ~TDDSurface(void);

__published:
    __property TDDSFileType FileType = {read=FFileType, write=FFileType, default=1};
    __property bool Locked = {read=FLocked};
    __property bool AutoColorKey = {read=FAutoColorKey, write=FAutoColorKey, stored=true, default=true};
    __property AnsiString FileName = {read=FFileName, write=FFileName};
    __property int Width = {read=FWidth, write=FWidth};
    __property int Height = {read=FHeight, write=FHeight};
    __property TNotifyEvent OnUpdate = {read=FOnUpdate, write=FOnUpdate};
    __property TNotifyEvent OnInit = {read=FOnInit, write=FOnInit};
};
//---------------------------------------------------------------------------
#endif
