//---------------------------------------------------------------------------
// Copyright (C) 1999 by Dmitriy Vassiliev
// SlyDiman@mail.ru
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "MdCmbBox.h"

#pragma package(smart_init)   
#pragma resource "*.res"

//---------------------------------------------------------------------------
namespace Mdcmbbox
{
    void __fastcall PACKAGE Register()
    {
        TComponentClass classes[1] = {__classid(TDDModesCombo)};
        RegisterComponents("SlyDiman", classes, 0);
    }
}

//---------------------------------------------------------------------------
__fastcall TDDModesCombo::TDDModesCombo(TComponent* Owner) : TCustomComboBox(Owner)
{
  FShow8bit  = false;
  FShow15bit = false;
  FShow16bit = true;
  FShow24bit = false;
  FShow32bit = true;
  FShowRatio4x3 = true;
  FShowMaxWidth = 1024;

  if( Owner->ClassParent()->ClassNameIs("TDDForm") ){
    FDDForm = (TDDForm *)Owner;
  }else{
    FDDForm = NULL;
  }

  Sorted = false;
  Style = csDropDownList;
}

//----------------------------------------------------------------------------
HRESULT WINAPI EnumModesCallback( LPDDSURFACEDESC2 lpDDSurfaceDesc, LPVOID lpContext )
{
  TDDModesCombo *DDModesCombo = (TDDModesCombo *)lpContext;
  int bits = lpDDSurfaceDesc->ddpfPixelFormat.dwRGBBitCount;
  if( (bits ==  8 && DDModesCombo->Show8bit ) ||
      (bits == 15 && DDModesCombo->Show15bit) ||
      (bits == 16 && DDModesCombo->Show16bit) ||
      (bits == 24 && DDModesCombo->Show24bit) ||
      (bits == 32 && DDModesCombo->Show32bit) ){

    if( DDModesCombo->ShowMaxWidth < lpDDSurfaceDesc->dwWidth )
      return( DDENUMRET_OK );

    if( DDModesCombo->ShowRatio4x3 )
      if( lpDDSurfaceDesc->dwWidth*3/4 != lpDDSurfaceDesc->dwHeight )
        return( DDENUMRET_OK );

    char str[20];
    DWORD Data = lpDDSurfaceDesc->dwWidth | (lpDDSurfaceDesc->dwHeight << 12) | (bits << 24);
    wsprintf( str, "%dx%d %dbpp", lpDDSurfaceDesc->dwWidth, lpDDSurfaceDesc->dwHeight, bits );
    DDModesCombo->Items->AddObject( AnsiString(str), (TObject *)Data );
  }

  return( DDENUMRET_OK );
}

//---------------------------------------------------------------------------
void __fastcall TDDModesCombo::CreateWnd(void)
{
  TCustomComboBox::CreateWnd();

  Init();
}

//---------------------------------------------------------------------------
void __fastcall TDDModesCombo::SetDDForm(TDDForm *_DDForm)
{
  if( FDDForm == _DDForm )  return;
  FDDForm = _DDForm;
  Init();
}

//---------------------------------------------------------------------------
void __fastcall TDDModesCombo::Init(void)
{
  Items->Clear();

  if( !(DDForm && DDForm->pDDraw) )  return;

  DDForm->pDDraw->EnumDisplayModes( 0, NULL, this, EnumModesCallback );

  FixIndex();
}

//---------------------------------------------------------------------------
void __fastcall TDDModesCombo::FixIndex(void)
{
  ItemIndex = 0;

//  if( !DDForm->pDDPrimary )  return;

  int obj = DDForm->DDWidth | (DDForm->DDHeight << 12) | (DDForm->DDBPP << 24);

  ItemIndex = Items->IndexOfObject( (TObject *)obj );
}

//---------------------------------------------------------------------------
