//---------------------------------------------------------------------------
// Copyright (C) 2000 by SlyDiman
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TileBlt.h"

//---------------------------------------------------------------------------
void TileBlt( IDirectDrawSurface7 *dstSurface,
              RECT * dstRect,
              IDirectDrawSurface7 *srcSurface,
              RECT * srcRect )
{


  int y = 0;
  int h = srcRect->bottom;
  do{
    if( y + h > dstRect->bottom )  h = dstRect->bottom - y;
    if( h <= 0 )  break;

    int x = 0;
    int w = srcRect->right;
    do{
      if( x + w > dstRect->right )  w = dstRect->right - x;
      if( w <= 0 )  break;
      RECT sRect = Rect(srcRect->left, srcRect->top, srcRect->left + w, srcRect->top + h );
      dstSurface->BltFast( dstRect->left + x, dstRect->top + y, srcSurface, &sRect, DDBLTFAST_WAIT );
      x += w;
    }while( x < dstRect->right );
    y += h;
  }while( y < dstRect->bottom );
}

//---------------------------------------------------------------------------
void TileBltEx( IDirectDrawSurface7 *dstSurface,
                RECT * dstRect,
                IDirectDrawSurface7 *srcSurface,
                RECT * srcRect )
{

  DDBLTFX     ddbltfx;
  ZeroMemory(&ddbltfx, sizeof(ddbltfx));
  ddbltfx.dwSize = sizeof(ddbltfx);

  int y = 0;
  int h = srcRect->bottom;
  int j = 0;
  do{
    if( y + h > dstRect->bottom )  h = dstRect->bottom - y;
    if( h <= 0 )  break;

    int x = 0;
    int w = srcRect->right;
    int i = 0;
    do{
      if( x + w > dstRect->right )  w = dstRect->right - x;
      if( w <= 0 )  break;

      ddbltfx.dwFillColor = 0x00FF00;
      int xx = dstRect->left + x;
      int yy = dstRect->top  + y;
      RECT dRect = Rect(xx, yy, xx + w, yy + h);

      ddbltfx.dwDDFX = 0;
      xx = 0;
      yy = 0;
      if( i ){
        ddbltfx.dwDDFX |= DDBLTFX_MIRRORLEFTRIGHT;
        xx = srcRect->right - w;
      }
      if( j ){
        ddbltfx.dwDDFX |= DDBLTFX_MIRRORUPDOWN;
        yy = srcRect->bottom - h;
      }
/*
DDBLTFX_ROTATE180
DDBLTFX_ROTATE270
DDBLTFX_ROTATE90
*/
      RECT sRect = Rect(xx, yy, xx + w, yy + h);
      dstSurface->Blt(&dRect, srcSurface, &sRect, DDBLT_DDFX  | DDBLT_WAIT, &ddbltfx);

      i ^= 1;
      x += w;
    }while( x < dstRect->right );
    j ^= 1;
    y += h;
  }while( y < dstRect->bottom );
}

//---------------------------------------------------------------------------


